program BatcherBitonicSort;
{
COMPLEJIDAD:
Procesadores: O(n)
HISTORIA: bug corregido. 16.10.93:

	    i := center+name-left+1;
	    xi := x[i];
}
const
  maxElements = 8191; (* debera ser de la forma 2^n - 1 *)
  logmaxElements = 13;
{

N  - 2^N
7  - 128
8  - 256
9  - 512
10 - 1024
11 - 2048
12 - 4096
13 - 8192
}

type   vector = array [0..maxElements] of integer;

var
  x : vector;
  n : integer; (* dimension *)
  logn : integer;
  t, timer : integer;

  procedure readVector;
  var i : integer;
  begin
    writeln('Bitonic Sort');
    write('n = (power of two and 0 < n <=',maxElements+1,') : ');
    readln(n);
    write('log n (base is 2) = ');
    readln(logn);
    for i := 0 to n-1 do
      begin
	{ write('x[',i,'] = '); }
	read(x[i]);
      end;
  end;

  procedure generateVector;
  var
    i : integer;
  begin
    n := maxElements+1;
    logn := logMaxElements;
    randomize;
    for i := 0 to maxElements do
      begin
	x[i] := random(1000);
	{ 
	if (i mod 10) = 0 then
	write(x[i],' '); 
	}
      end;
  end;

  procedure writeVector;
  var i : integer;
  begin
    for i := 0 to n-1 do
      begin
        write('x[',i,'] = ',x[i],' ');
      end;
    writeln;
  end;


  procedure bSort(left,right : integer;direction : boolean);
  (* ordena la secuencia bitonica x en orden ascendente si *)
  (* direction es TRUE y en orden descendente si es FALSE  *)
  begin
    if right > left then
      var nam, center : integer;
      begin
        center := (left + right) div 2;
        for nam := left to center do
          var i, temp1, temp2, xname, xi : integer;
          begin
            xname := x[nam] ;
            i := center+nam-left+1;
            xi := x[i];
            temp1 := xname min xi;
            temp2 := xname max xi;
            if direction then
              begin
                x[nam] := temp1;
                x[i] := temp2;
              end
            else
              begin
                x[nam] := temp2;
                x[i] := temp1;
              end;
          end;
        bSort(left,center,direction);
        bSort(center+1,right,direction);
      end
  end (* bSort *);


  procedure bitonicSort;
  var
    length, i, numOfIntervals, nam : integer;
  begin
    for i := 1 to logn do
      begin
        length := &i;
        writeln('length= ', length);
        numOfIntervals := n div length;
        writeln('intervals= ', numOfIntervals);
        for nam := 0 to (numOfIntervals-1) do
          var first, last : integer;
          begin
            first := nam*length;
            last := first+length-1;
            bSort(first,last,(nam mod 2 = 0));
          end;
     end;
  end;

begin
  writeln('Maximo N de elementos: ', maxElements);
  
  readVector; 
  { generateVector; }

  writeln;
  writeln('Vector generado.');


  writeln('Comienza la ordenacin.');
  settime(t);
  bitonicSort;
  gettime(timer,t);
  writeln('tiempo ',timer);
  writeln('Ordenacin FINALIZADA.');

  {writeVector;      }
end.
