program BatcherBitonicSort;
{
COMPLEJIDAD:
Procesadores: O(n)
}
const
  maxElements = 32; (* debera ser de la forma 2^n - 1 *)
  logmaxElements = 5;
{

N  - 2^N
7  - 128
8  - 256
9  - 512
10 - 1024
11 - 2048
12 - 4096
13 - 8192
}

type   vector = array [0..maxElements] of integer;

var
  a,b : vector;
  n : integer; (* dimension *)
  n1, logn : integer;

  procedure readVector;
  var i : integer;
  begin
    writeln('Bitonic Sort');
    write('n = (power of two and 0 < n <=',maxElements+1,') : ');
    readln(n);
    write('log n (base is 2) = ');
    readln(logn);
    n1 := n-1;
    for i := 0 to n1 do
      begin
       read(a[i]);
      end;
  end;

  procedure generateVector;
  var
    i : integer;
  begin
    n := maxElements+1;
    n1 := maxElements;
    logn := logMaxElements;
    randomize;
    for i := 0 to maxElements do
      begin
	a[i] := random(1000);
	{
	if (i mod 10) = 0 then
	write(a[i],' ');
	}
      end;
  end;

  procedure writeVector;
  var i : integer;
  begin
    writeln;
    for i := 0 to n1 do
      begin
        write(' ',a[i],' ');
      end;
    readln;
  end;



procedure batcher;
var count, i,j,t,s,u : integer;
begin
  count:= 0;
  while (count < n1) do
    begin
      i := 0;
      while ( i < logn) do
        begin
         j := i;
         while (j >= 0) do
           begin
             t := a[name];
             s := a[name or (&j)];
             u := a[name xor (&j)];
             if name and (&(i+1)) = 0 then
               begin
                 if (name and (&j)) = 0 then
						  t := t min s
						else
						  t := t max u;
						a[name] := t;
					 end
				  else
					 begin
						if (name and (&j)) = 0 then
						  t := t max s
						else
						  t := t min u;
						a[name] := t;
					 end;
				  j := j-1;
			end (* while j *);
			i := i+1;
		 end (* while i *)
	 end (* while count *);
end (* batcher *);

begin
  writeln('Maximo N de elementos: ', maxElements);

  readVector;
  { generateVector; }

  writeln;
  writeln('Vector generado.');


  writeln('Comienza la ordenacin.');
  batcher;
  writeln('Ordenacin FINALIZADA.');

  writeVector;
end.
